from PyTASTileType import *
from NeighborGlues import *
from internal_tests.structures.StructureLine import StructureLine

# Defines the temperature the simulator will use while adding tiles from this module
TEMPERATURE = 2

## A west moving line
finalTile = PyTASTileType()
finalTile.name = "LineFinalTileName"
finalTile.label = "LineFinalTileLabel"
finalTile.sides[N] = Glue(TEMPERATURE,"EndOfLineTileNorth")
finalTile.color = "RED"
theLine = StructureLine(3,W,1,Glue(3,"Foo"),finalTile)

## A second, north moving line
finalTile2 = PyTASTileType()
finalTile2.name = "LineFinal2TileName"
finalTile2.label = "LineFinal2TileLabel"
finalTile2.sides[N] = Glue(TEMPERATURE,"EndOfLine2TileNorth")
finalTile2.sides[E] = Glue(TEMPERATURE,"EndOfLine2TileEast")
finalTile2.color = "BLUE"
theLine2 = StructureLine(TEMPERATURE,N,5,finalTile.sides[N],finalTile2)

# Main list of structures which are checked for new tiles
StructuresList = [theLine,theLine2]

#  GetSeed is the function called by the simulator to get the definitions and
#  locations of tiles in the seed
def GetSeed():
    returnSet = set()
    
    
    t = PyTASTileType()
    t.name = "seed1"
    t.label = "seed1label"
    t.sides[W] = Glue(3,"Foo")
    t.color = "GREEN"
    
    tLocation = (0,0,0)
    returnSet.add( (t,tLocation) )
    
    # Get Seed tiles from all structures
    for structure in StructuresList:
        returnSet.update(structure.GetSeed())
    return returnSet

#  GetTileTypes is the function called by the simulator as it encounters frontier locations
def GetTileTypes(nbrGlues):
    #print("In testGenerateABC_main GetTileTypes()")
    returnSet = set()
    
    # Check all structures for viable tiles
    for structure in StructuresList:
        returnSet.update(structure.GetTileTypes(nbrGlues))
    return returnSet